ompi/class/ompi_bitmap.h File Reference.TH "ompi/class/ompi_bitmap.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/class/ompi_bitmap.h \- A bitmap implementation. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef ompi_bitmap_t \fBompi_bitmap_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (ompi_bitmap_t)"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_init\fP (ompi_bitmap_t *bm, int size)"
.br
.RI "\fIInitializes the bitmap and sets its size. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_set_bit\fP (ompi_bitmap_t *bm, int bit)"
.br
.RI "\fISet a bit of the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_clear_bit\fP (ompi_bitmap_t *bm, int bit)"
.br
.RI "\fIClear/unset a bit of the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_is_set_bit\fP (ompi_bitmap_t *bm, int bit)"
.br
.RI "\fIFind out if a bit is set in the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_find_and_set_first_unset_bit\fP (ompi_bitmap_t *bm, int *position)"
.br
.RI "\fIFind the first clear bit in the bitmap and set it. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_clear_all_bits\fP (ompi_bitmap_t *bm)"
.br
.RI "\fIClear all bits in the bitmap. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_bitmap_set_all_bits\fP (ompi_bitmap_t *bm)"
.br
.RI "\fISet all bits in the bitmap. \fP"
.ti -1c
.RI "static int \fBompi_bitmap_size\fP (ompi_bitmap_t *bm)"
.br
.RI "\fIGives the current size (number of bits) in the bitmap. \fP"
.in -1c
.SH "Detailed Description"
.PP 
A bitmap implementation. 

The bits start off with 0, so this bitmap has bits numbered as bit 0, bit 1, bit 2 and so on. This bitmap has auto-expansion capabilities, that is once the size is set during init, it can be automatically expanded by setting the bit beyond the current size. But note, this is allowed just when the bit is set -- so the valid functions are set_bit and find_and_set_bit. Other functions like clear, if passed a bit outside the initialized range will result in an error.
.PP
Since these bitmaps are only used to track fortran handles (which MPI defines to be int's), it is assumed that we can never have more than OMPI_FORTRAN_HANDLE_MAX (which is min(INT_MAX, fortran INTEGER max)).
.PP
--------------------------------------------------------------------
.PP
There are several classes that have forked between their OMPI and ORTE implementations. As of this writing:
.PP
.IP "\(bu" 2
ompi_bitmap and orte_bitmap
.IP "\(bu" 2
ompi_pointer_array and orte_pointer_array
.IP "\(bu" 2
opal_value_array and orte_value_array
.PP
.PP
Short version:
.PP
They were split to accomodate a few differences between requirements (e.g., 'size' parameters being int vs. size_t). It would be nice to re-merge them someday; there's a few technical issues that would need to be solved, but nothing impossible. But there's no pressing *need* to re-merge these, so they have fallen somewhat low on the priority list of things to do.
.PP
Longer version:
.PP
Although these are generic functionality classes, the ORTE versions split from the OMPI (soon to be OPAL) versions because of restrictions imposed by the OMPI versions. Specifically, the OMPI versions specifically limit size arguments to 'int' (in multiple different ways, e.g.: types of 'size' parameters to functions, maximum allowable values of size parameters, etc.). The ORTE functions need most size parameters to be of type size_t, not int. This is the most fundamental difference. In C++, we could have templated these functions, but we unfortunately can't easily do that in C (in hindsight, perhaps some preprocessor macros might have been sufficient, but...).
.PP
Another, more subtle, reason why these were split because of the scary word 'FORTRAN' that appears in some of the upper value limit checks in the OMPI versions. That is, we always check for max size against OMPI_FORTRAN_HANDLE_MAX. This value is simply min(INT_MAX, max value of Fortran INTEGER) -- it's the minimum of the maximum values of integers in C and Fortran. Usually, it's the same value (2^32), but the macro is there to ensure that even if it's different, we end up with a value that can be represented in both languages.
.PP
This is because the primary purpose of these classes is to serve as an interface to the Fortran language bindings -- fortran handles may be directly represented as indices into arrays or bitmaps. Hence, the size has to be representable in both C and Fortran.
.PP
Regardless, we need to check for *some* max value for the size of these entites. Perhaps the name 'FORTRAN' in the macro is scary/misleading -- it can certainly be changed in the future if it would be more clear. So it's ok to have a max -- but perhaps changing the name would make it more palatable to both layers (remebering that the max value is still going to be enormous -- usually 2^32; even if the size is of type size_t, you're going to run out of memory long before you have 2^32 entries). Or perhaps the max value can be parameterized to depend on whether the size type is int or size_t -- I'm sure something can be worked out.
.PP
As mentioned above, if these really are the only two differences (int vs. size_t and the max sentinel value) -- and I'm pretty sure that they are -- then these classes can be re-merged someday, resulting in less code to maintain. This would be good for long-term maintenance. However, it's kinda low on the priority list. So it hasn't been done [yet]. If someone wants to do this, please feel free! :-)
.PP
Given the fact that we just had yet another round of discussions about the splitting / re-merging of these classes (26 May 2005), it was decided to put this big comment in the hopes of:
.PP
.IP "\(bu" 2
someday motivating someone to re-merge the classes
.IP "\(bu" 2
prevent yet-another round of these discussions by documenting the issues once and for all :-)
.PP

.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int ompi_bitmap_clear_all_bits (ompi_bitmap_t * bm)"
.PP
Clear all bits in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code if bm is NULL 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_clear_bit (ompi_bitmap_t * bm, int bit)"
.PP
Clear/unset a bit of the bitmap. 
.PP
If the bit is beyond the current size of the bitmap, an error is returned
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be cleared (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code if the bit is out of range, else success 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_find_and_set_first_unset_bit (ompi_bitmap_t * bm, int * position)"
.PP
Find the first clear bit in the bitmap and set it. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIposition\fP Position of the first clear bit (OUT)
.RE
.PP
\fBReturns:\fP
.RS 4
err OMPI_SUCCESS on success 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_init (ompi_bitmap_t * bm, int size)"
.PP
Initializes the bitmap and sets its size. 
.PP
This must be called before the bitmap can be actually used
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIsize\fP The initial size of the bitmap in terms of bits (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code or success 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_is_set_bit (ompi_bitmap_t * bm, int bit)"
.PP
Find out if a bit is set in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be checked (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code if the bit is out of range 1 if the bit is set 0 if the bit is not set 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_set_all_bits (ompi_bitmap_t * bm)"
.PP
Set all bits in the bitmap. 
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code if bm is NULL 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_bitmap_set_bit (ompi_bitmap_t * bm, int bit)"
.PP
Set a bit of the bitmap. 
.PP
If the bit asked for is beyond the current size of the bitmap, then the bitmap is extended to accomodate the bit
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.br
\fIbit\fP The bit which is to be set (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code or success 
.RE
.PP

.SS "static int ompi_bitmap_size (ompi_bitmap_t * bm)\fC [inline, static]\fP"
.PP
Gives the current size (number of bits) in the bitmap. 
.PP
This is the legal (accessible) number of bits
.PP
\fBParameters:\fP
.RS 4
\fIbitmap\fP The input bitmap (IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code if bm is NULL 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
